<?php
class WPaymentAuthorizenetAdminParams extends UParamsWorklet
{
	public function accessRules()
	{
		return array(
			array('allow', 'roles' => array('administrator')),
			array('deny', 'users'=>array('*'))
		);
	}
	
	public function title()
	{
		return;
	}
	
	public function properties()
	{
		return array(
			'elements' => array(
				'name' => array('type' => 'text', 'label' => $this->t('Name')),
				'apiLogin' => array('type' => 'text', 'label' => $this->t('API Login'), 'class' => 'large'),
				'apiTransactionKey' => array('type' => 'text', 'label' => $this->t('Transaction Key'), 'class' => 'large'),
				'apiMD5Hash' => array('type' => 'text', 'label' => $this->t('MD5 Setting'), 'class' => 'large'),
				'sandbox' => array('type' => 'radiolist', 'label' => $this->t('Sandbox'),
					'items' => array(
						0 => $this->t('Disable'),
						1 => $this->t('Enable')
					), 'layout' => "{label}\n<fieldset>{input}\n{hint}</fieldset>"
				),
				'cconly' => array('type' => 'radiolist', 'label' => $this->t('Use As'),
					'items' => array(
						1 => $this->t('Gateway for direct credit card payments only'),
						0 => $this->t('Gateway and standalone payment method')
					), 'layout' => "{label}\n<fieldset>{input}\n{hint}</fieldset>"
				),
			),
			'buttons' => array(
				'submit' => array('type' => 'submit', 'label' => $this->t('Save'))
			),
			'model' => $this->model
		);
	}
}